import java.util.ArrayList;

public class Cavalier extends Piece {
    public Cavalier(String coul) {
        super(coul);
    }

    @Override
    public ArrayList<Case> getDepPossibles(Echiquier ech) {
        ArrayList<Case> depPossible = new ArrayList<>();
        int caseBas = this.getL()+1;
        int caseHaut = this.getL()-1;
        int caseDroite = this.getC()+1;
        int caseGauche = this.getC()-1;
        Case caseLibre;


        /*HAUT-DROITE*/

        if(ech.caseExiste(caseHaut-1,caseDroite)){
            if(ech.getPiece(caseHaut-1, caseDroite)==null){
                caseLibre = new Case(caseHaut-1, caseDroite);
                depPossible.add(caseLibre);
            } else {
                if(!ech.getPiece(caseHaut-1, caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut-1,caseDroite);
                    depPossible.add(caseLibre);
                }
            }
        }


        /*HAUT-GAUCHE*/

        if(ech.caseExiste(caseHaut-1,caseGauche)){
            if(ech.getPiece(caseHaut-1, caseGauche)==null){
                caseLibre = new Case(caseHaut-1, caseGauche);
                depPossible.add(caseLibre);
            } else {
                if(!ech.getPiece(caseHaut-1, caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut-1,caseGauche);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*DROITE - HAUT*/
        if(ech.caseExiste(caseHaut,caseDroite+1)){
            if(ech.getPiece(caseHaut, caseDroite+1)==null){
                caseLibre = new Case(caseHaut, caseDroite+1);
                depPossible.add(caseLibre);
            } else {
                if(!ech.getPiece(caseHaut, caseDroite+1).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,caseDroite+1);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*DROITE - BAS*/
        if(ech.caseExiste(caseBas,caseDroite+1)){
            if(ech.getPiece(caseBas, caseDroite+1)==null){
                caseLibre = new Case(caseBas, caseDroite+1);
                depPossible.add(caseLibre);
            } else {
                if(!ech.getPiece(caseBas, caseDroite+1).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,caseDroite+1);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*BAS - DROITE*/
        if(ech.caseExiste(caseBas+1,caseDroite)){
            if(ech.getPiece(caseBas+1, caseDroite)==null){
                caseLibre = new Case(caseBas+1, caseDroite);
                depPossible.add(caseLibre);
            } else {
                if(!ech.getPiece(caseBas+1, caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas+1,caseDroite);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*BAS - GAUCHE*/
        if(ech.caseExiste(caseBas+1,caseGauche)){
            if(ech.getPiece(caseBas+1, caseGauche)==null){
                caseLibre = new Case(caseBas+1, caseGauche);
                depPossible.add(caseLibre);
            } else {
                if(!ech.getPiece(caseBas+1, caseGauche).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas+1,caseGauche);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*GAUCHE - BAS*/
        if(ech.caseExiste(caseBas,caseGauche-1)){
            if(ech.getPiece(caseBas, caseGauche-1)==null){
                caseLibre = new Case(caseBas, caseGauche-1);
                depPossible.add(caseLibre);
            } else {
                if(!ech.getPiece(caseBas, caseGauche-1).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,caseGauche-1);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*GAUCHE - HAUT*/
        if(ech.caseExiste(caseHaut,caseGauche-1)){
            if(ech.getPiece(caseHaut, caseGauche-1)==null){
                caseLibre = new Case(caseHaut, caseGauche-1);
                depPossible.add(caseLibre);
            } else {
                if(!ech.getPiece(caseHaut, caseGauche-1).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,caseGauche-1);
                    depPossible.add(caseLibre);
                }
            }
        }


        return depPossible;
    }

    @Override
    public String toString() {
        String nom = null;
        if (getCoul() == BLANC){
            nom = "CB";
        }else {
            nom = "CN";
        }
        return nom;
    }
}
