import java.util.ArrayList;

/**
 *
 * @author gsimon
 * CLASSE A COMPLETER !
 * Classe permettant de gérer les déplacements d'un roi
 * NB : Dans un premier temps, ne pas tenir compte
 * du problème de mise en échec éventuelle
 */
public class Roi extends Piece {

    public Roi(String coul) {
        super(coul);
    }

    @Override
    public boolean isRoi() { return true; }
    
    @Override
    public ArrayList<Case> getCasesPossibles(Echiquier ech) {

        /*
         * Par rapport aux autres pièces, ici il faudrait vérifier 
         * après avoir récupéré lesdéplacements possibles qu'il n'y
         * a pas de mise en échec (en utilisant isEchec de Echiquier).
         */

        
        //on calcule les cases atteignables sans tenir compte des échecs
        ArrayList<Case> adp = getDepPossibles(ech);
        
        return adp;
    }
    public boolean isEchec(){

        return false;
    }

    //tenir compte des couleurs des pieces
    //une boucle par déplacement
    //verif case existe
    //si vide -> case dispo
    // si non
    //      -> la piece est de la meme couleur -> case impossible
    //      -> couleur opposé -> case dispo

    @Override
    public ArrayList<Case> getDepPossibles(Echiquier ech) {
        ArrayList<Case> depPossible = new ArrayList<>();
        int caseBas = this.getL()+1;
        int caseHaut = this.getL()-1;
        int caseDroite = this.getC()+1;
        int caseGauche = this.getC()-1;
        Case caseLibre;

        /*Haut*/
        if(ech.caseExiste(caseHaut,this.getC())){
            if(ech.getPiece(caseHaut,this.getC()) == null){
                caseLibre = new Case(caseHaut,this.getC());
                depPossible.add(caseLibre);
            }else{
                if (!ech.getPiece(caseHaut,this.getC()).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,this.getC());
                    depPossible.add(caseLibre);
                }
            }
        }

        /*Haut droite*/
        if(ech.caseExiste(caseHaut,caseDroite)){
            if(ech.getPiece(caseHaut,caseDroite) == null){
                caseLibre = new Case(caseHaut,caseDroite);
                depPossible.add(caseLibre);
            }else{
                if (!ech.getPiece(caseHaut,caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,caseDroite);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*Droite*/
        if(ech.caseExiste(this.getL(),caseDroite)){
            if(ech.getPiece(this.getL(),caseDroite) == null){
                caseLibre = new Case(this.getL(),caseDroite);
                depPossible.add(caseLibre);
            }else{
                if (!ech.getPiece(this.getL(),caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(this.getL(),caseDroite);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*Bas droit*/
        if(ech.caseExiste(caseBas,caseDroite)){
            if(ech.getPiece(caseBas,caseDroite) == null){
                caseLibre = new Case(caseBas,caseDroite);
                depPossible.add(caseLibre);
            }else{
                if (!ech.getPiece(caseBas,caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,caseDroite);
                    depPossible.add(caseLibre);
                }
            }
        }
        /*Bas*/
        if(ech.caseExiste(caseBas,this.getC())){
            if(ech.getPiece(caseBas,this.getC()) == null){
                caseLibre = new Case(caseBas,this.getC());
                depPossible.add(caseLibre);
            }else{
                if (!ech.getPiece(caseBas,this.getC()).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,this.getC());
                    depPossible.add(caseLibre);
                }
            }
        }

        /*Bas gauche*/
        if(ech.caseExiste(caseBas,caseGauche)){
            if(ech.getPiece(caseBas,caseGauche) == null){
                caseLibre = new Case(caseBas,caseGauche);
                depPossible.add(caseLibre);
            }else{
                if (!ech.getPiece(caseBas,caseGauche).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,caseGauche);
                    depPossible.add(caseLibre);
                }
            }
        }

        /* gauche */
        if(ech.caseExiste(this.getL(),caseGauche)){
            if(ech.getPiece(this.getL(),caseGauche) == null){
                caseLibre = new Case(this.getL(),caseGauche);
                depPossible.add(caseLibre);
            }else{
                if (!ech.getPiece(this.getL(),caseGauche).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(this.getL(),caseGauche);
                    depPossible.add(caseLibre);
                }
            }
        }

        /*Déplacement NORD-OUEST*/
        if(ech.caseExiste(caseHaut,caseGauche)){
            if(ech.getPiece(caseHaut,caseGauche) == null){
                caseLibre = new Case(caseHaut,caseGauche);
                depPossible.add(caseLibre);
            }else{
                if (!ech.getPiece(caseHaut,caseGauche).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,caseGauche);
                    depPossible.add(caseLibre);
                }
            }
        }




        return depPossible;
    }

    @Override
    public String toString() {
        String nom =null;
        if (getCoul()==BLANC){
            nom = "RB";
        }else{
            nom="RN";
        }

        return nom;
    }


}
