/*
 * Tests simples avec :
 * - alternance des coups entre blanc et noir
 * - pas de mise en échec des rois
 * Dans cette version des échecs, on ne tient pas compte des mises en échec
 * éventuelles des rois que ce soit dans un déplacement ou dans le calcul
 * des déplacements possibles.
 */

/**
 *
 * @author gsimon
 */
public class TestEchiquier {

    public static void main(String[] args) {
        Echiquier ech;
        String prise; //texte décrivant une prise

        //on crée un échiquier vide
        ech = new Echiquier(); 
        System.out.println("Echiquier vide");
        System.out.println(ech);

        //on positionne deux tours, deux rois, 1 fou, 1 cavalier, 1 reine
        Piece t = new Tour(Piece.BLANC);
        ech.placer(t, 0, 0);
        t = new Tour(Piece.NOIR);
        ech.placer(t, 0, 4);
        Piece r = new Roi(Piece.NOIR);
        ech.placer(r, 7, 3);
        r =new Roi(Piece.BLANC);
        ech.placer(r, 1, 3);
        Piece f = new Fou(Piece.NOIR);
        ech.placer(f,3,1);
        Piece c = new Cavalier(Piece.BLANC);
        ech.placer(c,2,4);
        Piece re = new Reine(Piece.NOIR);
        ech.placer(re,6,1);
        Piece p = new Pion(Piece.BLANC);
        ech.placer(p,6,7);
        System.out.println("Echiquier initial");
        System.out.println(ech);

        //affichage des déplacements possibles de la tour blanche
        System.out.println();
        ech.afficherDepPossibles(0, 0);
        System.out.println();
        
        //déplacement de la tour blanche en (0,4)
        //elle prend la tour noire
        System.out.println();
        prise = ech.deplacer(0, 0, 0, 4); //on déplace la tour en haut à gauche
        if (prise != null) { System.out.println(prise); }
        System.out.println(ech);
        
        //affichage des déplacements possibles du roi noir
        System.out.println();
        ech.afficherDepPossibles(7, 3);
        
        //déplacement du roi noir
        System.out.println();
        prise = ech.deplacer(7, 3, 6, 3); //on déplace le roi vers le haut
        if (prise != null) { System.out.println(prise); }
        System.out.println(ech);

        //affichage des déplacements possibles de la tour blanche
        // qui vient d'être déplacée
        System.out.println();
        ech.afficherDepPossibles(0, 4);
        System.out.println();

        //déplacement de la tour blanche en haut à droite du roi noir
        System.out.println();
        prise = ech.deplacer(0, 4, 5, 4); 
        if (prise != null) { System.out.println(prise); }
        System.out.println(ech);

        //déplacements possibles du roi en (6,4)
        System.out.println();
        ech.afficherDepPossibles(6,3);
        
        //on essaie de déplacer le roi noir en (2,4) : déplacement refusé
        //erreur : case inacessible !
        System.out.println();
        prise = ech.deplacer(6,3,2,4); 
        if (prise != null) { System.out.println(prise); }
        System.out.println(ech);
        
        //on déplace finalement le roi noir sur la tour blanche 
        System.out.println();
        prise = ech.deplacer(6,3,5,4); 
        if (prise != null) { System.out.println(prise); }
        System.out.println(ech);

        //deplacement possible de fou noir
        System.out.println();
        ech.afficherDepPossibles(3,1);

        //déplacement possible du cavalier blanc
        System.out.println();
        ech.afficherDepPossibles(2,4);

        //deplacement possible de la reine noire
        System.out.println();
        ech.afficherDepPossibles(6,1);
    }

}
